#ifndef __adaption__
#ifdef __GNUG__
#pragma interface
#endif
#define __adaption__

#include <vector>
#include <cassert>
#include "RefCounter.hpp"
#include "RNM.hpp"



using namespace std;
void adaption_t(const vector<double> & old_grid, const  vector<double> &estim,vector<double> & new_grid, const double threshold, const int  max_aspect_ratio);
void adaption_t2(const vector<double> & old_grid, const  vector<double> &estim,vector<double> & new_grid, const double estim_factor, const int  max_aspect_ratio);
void adaption_t2(const vector<double> & old_grid, const vector<vector<double> > &old_grid_S,  const vector<int> &old_change_grid, const  vector<double> &estim,vector<double> & new_grid, vector<vector<double> > &new_grid_S, vector<int> &new_change_grid,vector<vector<double> > &new_step_S,  const double estim_factor, const int  max_aspect_ratio);
void adaption_t3(const vector<double> & old_grid, const  vector<double> &estim,vector<double> & new_grid, const double estim_factor, const int  max_aspect_ratio);

void adaption_S(const vector<double> & old_grid, const  KN<double> &estim,vector<double> & new_grid, const double maxestim, 
		const double reduction_factor,const int  max_aspect_ratio);


void amer_adaption_S(const vector<double> & old_grid, const  KN<double> &estim,vector<double> & new_grid, const double maxestim, 
		const double reduction_factor,const int  max_aspect_ratio, const double);

void adaption_S(const vector<double> & old_grid, const  KN<double> &estim,vector<double> & new_grid, const double threshold, const int  max_aspect_ratio);
void adaption_S(const vector< vector<double> >& old_grid, const vector< KN<double> >&estim, vector< vector<double> >& new_grid, vector< vector<double> >& new_steps, vector<int> & change_grid,  const double threshold, const int  max_aspect_ratio);



void adaption_tS(const vector<double> & old_t_grid, const  vector<double> &estim,vector<double> & new_t_grid, const double estim_factor, const int  max_aspect_ratio,const vector< vector<double> >& old_S_grid, const vector<int> & old_change_grid, const vector< vector<double> >& old_steps,
		 const vector< KN<double> >&estim_S, vector< vector<double> >& new_S_grid, vector< vector<double> >& new_steps, vector<int> & change_grid,  const double threshold, const int  max_aspect_ratio_S, const vector<double> & global_estim_S, int);
void amer_adaption_tS(const vector<double> & old_t_grid, const  vector<double> &estim,vector<double> & new_t_grid, const double estim_factor, const int  max_aspect_ratio,const vector< vector<double> >& old_S_grid, const vector<int> & old_change_grid, const vector< vector<double> >& old_steps,
		 const vector< KN<double> >&estim_S, vector< vector<double> >& new_S_grid, vector< vector<double> >& new_steps, vector<int> & change_grid,  const double threshold, const int  max_aspect_ratio_S, const vector<double> & global_estim_S, int, const double);


#endif
